﻿using UnityEngine;
using System.Collections;

public class InteractiveElement : Element 
{
    protected ElementSettings.InteractionType m_InteractionType;
    public ElementSettings.InteractionType InteractionType
    {
        get { return m_InteractionType; }
    }
    protected bool m_Used;
    public bool Used
    {
        get { return m_Used; }
    }
    protected InteractTrigger m_Trigger;

    protected override void OnEnable()
    {
        base.OnEnable();
    }

    protected override void Start()
    {
        base.Start();
        m_Trigger = GetComponent<InteractTrigger>();
        if(m_Trigger == null) m_Trigger = GetComponentInChildren<InteractTrigger>();
    }
	
    public override bool UpdateElement()
    {
        return base.UpdateElement();
    }

    public virtual void UseIt()
    {
    }

    public override void ReInit()
    {
        base.ReInit();
        m_Used = false;
    }
}